// ============================================================
// Project            :  Mi Pueblito
// File               :  .\game\gameScripts\fade.cs
// Copyright          :  
// Author             :  Pier
// Created on         :  Friday, September 07, 2007 1:47 PM
//
// Editor             :  Codeweaver v. 1.2.2594.2497
//
// Description        :  Para manejar el fading de objetos.
//                    :  
//                    :  
// ============================================================


// Cada cuando actualiza el fade
$FadeGranularity = 50;

// Funcion inicial
function t2dSceneObject::fadeFast(%this, %toAlpha, %time, %command) {
   %alpha = %this.getBlendAlpha();
   %updatesRemaining = %time / $FadeGranularity;
   %delta = (%toAlpha - %alpha) / %updatesRemaining;
   %this.fadeFastHelp(%toAlpha, %delta, %time, %command);
}


// Funcion auxiliar (no se adapta a cambios en la opacidad o a FadeGranularity)
function t2dSceneObject::fadeFastHelp(%this, %toAlpha, %delta, %time, %command) {
   if(%time > $FadeGranularity) {
      // Si no hemos acabado, cambiamos el alpha y programamos la proxima llamada
      %this.setBlendAlpha(%this.getBlendAlpha()+%delta);
      %this.fadeEvent = %this.schedule($FadeGranularity, fadeFastHelp, %toAlpha, %delta, %time - $FadeGranularity, %command);
   } else {
      // Sino, ponemos el alpha final y mandamos llamar la funcion de que termino
      %this.setBlendAlpha(%toAlpha);
      eval(%command);
   }
}