// ============================================================
// Project            :  Mi Pueblito
// File               :  .\game\gameScripts\audioDatablocks.cs
// Copyright          :  
// Author             :  Pier
// Created on         :  Sunday, August 05, 2007 3:06 PM
//
// Editor             :  Codeweaver v. 1.2.2594.2497
//
// Description        :  Archivo en el que creamos los sonidos
//                    : a utilizar en el juego. 
//                    :  
// ============================================================


// Para cargar canciones y sonidos que "loopean"
new AudioDescription(MusicDescription) {
   volume     = 1.0;
   isLooping  = true;
   isStreaming= true;
   is3D       = false;
   type       = $GuiAudioType;
};


// Para cargar canciones y sonidos que se detienen al terminar
new AudioDescription(FXDescription) {
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = $GuiAudioType;
};


// Cancion del menu
new AudioProfile(menuAudio) {
   filename = "~/data/audio/Urban Tribes.ogg";
   description = "MusicDescription";
   preload = false;
};


// Cancion del nivel
new AudioProfile(levelAudio) {
   filename = "~/data/audio/Summer Runner.ogg";
   description = "MusicDescription";
   preload = false;
};


// Sonido cuando explota la bomba
new AudioProfile(bombExplosion) {
   filename = "~/data/audio/bomb_explosion.wav";
   description = "FXDescription";
   preload = true;
};

// Sonido cuando se avienta la bomba
new AudioProfile(bombThrow) {
   filename = "~/data/audio/bomb_throw.wav";
   description = "FXDescription";
   preload = true;
};

// Sonido de la bomba cayendo
new AudioProfile(bombWhistle) {
   filename = "~/data/audio/bomb_whistle.wav";
   description = "FXDescription";
   preload = true;
};

// Sonido de las flores saliendo
new AudioProfile(flowerShower) {
   filename = "~/data/audio/flower_peace.wav";
   description = "FXDescription";
   preload = true;
};

// Sonido cuando presionan una opcion
new AudioProfile(click) {
   filename = "~/data/audio/click.wav";
   description = "FXDescription";
   preload = true;
};

// Sonido cuando pierden
new AudioProfile(gameOver) {
   filename = "~/data/audio/game_over.wav";
   description = "FXDescription";
   preload = true;
};

// Sonido cuando se seperan (al hacer click)
new AudioProfile(fightOver) {
   filename = "~/data/audio/huh.wav";
   description = "FXDescription";
   preload = true;
};

// Sonido cuando empiezan a pelear
new AudioProfile(fightStart) {
   filename = "~/data/audio/punch.wav";
   description = "FXDescription";
   preload = true;
};