// ============================================================
// Project            :  Mi Pueblito
// File               :  .\game\gameScripts\sun.cs
// Copyright          :  
// Author             :  Pier
// Created on         :  Tuesday, September 04, 2007 8:32 PM
//
// Editor             :  Codeweaver v. 1.2.2594.2497
//
// Description        :  Actualizamos los datos del sol y el 
//                    : cielo. 
//                    :  
// ============================================================


//
function sunFace::onLevelLoaded(%this) {
   // Vamos a actualizar al sol 5 veces por segundo
   %this.schedule (200, update);
}


//
function sunFace::update(%this) {
   // Calculamos cual cara tenemos que usar
   %frame= mFloor($currentLevel.angryPercent/2000);
   if (%frame > 4) {
      %frame= 4;
   }
   %this.setImageMap(sunImageMap, %frame);
   %this.schedule (200, update);
   
   // Cambiamos de color el fondo
   %color= 1 -($currentLevel.angryPercent/10000);
   cloudsScroll.setBlendColor( "1" SPC %color SPC %color);
}


//
function sunBack::onLevelLoaded(%this) {
   %this.creciendo= true;
   %this.cuenta= 25;
   // Vamos a actualizar al fondo 20 veces por segundo
   %this.schedule (50, update);
}


//
function sunBack::update(%this) {
   // Crecer / decrecer al sol
   %delta= (%this.creciendo) ? (0.03) : (-0.03);
   %this.setSizeX( %this.getSizeX() + %delta );
   %this.setSizeY( %this.getSizeY() + %delta );
   %this.cuenta--;
   if (%this.cuenta < 0) {
      %this.creciendo= !%this.creciendo;
      %this.cuenta= 25;
   }
   %this.schedule (50, update);
}